#include<bits/stdc++.h>
#define ll long long
using namespace std;

    ll niz1[75000];
    ll niz2[75000];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    while(t--){
        int n,m;
        cin>>n>>m;
        ll niz[n-1];
        cin>>niz1[0];
        for(int i=1;i<n;i++){
            cin>>niz1[i];
            niz[i-1]=abs(niz1[i-1]-niz1[i]);
        }

        for(int i=0;i<m;i++)
            cin>>niz2[i];
/*
        for(int i=0;i<n;i++){
            cerr<<niz[i]<<" ";
        }
        cerr<<"\n";
    */
        ll nzd;
        if(n==2){
            nzd=abs(niz1[0]-niz1[1]);
        }
        else
        nzd=__gcd(niz[0],niz[1]);

        for(int i=2;i<n;i++){
            nzd=__gcd(nzd,niz[i]);
            //cerr<<nzd<<" ";
        }
       // cerr<<nzd;
       // cerr<<"\n";
        bool o=true;
        for(int i=0;i<m;i++){
            ll u=abs(niz1[0]-niz2[i]);
           // cerr<<u<<" ";
            if(u%nzd==0 && u>nzd){
                o=false;
            }
           // cout<<"1\n";
        }
        if(o==true)
            cout<<"1\n";
        if(o==false)
            cout<<"0\n";

    }


    return 0;

}